// ColoredEdit.cpp : implementation file
//

#include "stdafx.h"
#include "ColoredEdit.h"


// CColoredEdit

IMPLEMENT_DYNAMIC(CColoredEdit, CEdit)
CColoredEdit::CColoredEdit()
{
 error = FALSE;
 bk.CreateSolidBrush(RGB(255, 0, 0));
}

CColoredEdit::~CColoredEdit()
{
}


BEGIN_MESSAGE_MAP(CColoredEdit, CEdit)
    ON_WM_CTLCOLOR_REFLECT()
END_MESSAGE_MAP()



// CColoredEdit message handlers


/****************************************************************************
*                         CColoredEdit::SetErrorMode
* Inputs:
*       BOOL mode: TRUE to indicate error, FALSE for no error
* Result: void
*       
* Effect: 
*       Sets the error mode
****************************************************************************/

void CColoredEdit::SetErrorMode(BOOL mode)
    {
     if(error == mode)
        return; // no change
     error = mode;
     if(GetSafeHwnd() != NULL)
        Invalidate();
    } // CColoredEdit::SetErrorMode

/****************************************************************************
*                           CColoredEdit::CtlColor
* Inputs:
*       CDC * pDC: DC to modify
*       UINT nCtlColor: unused
* Result: HBRUSH
*       Either NULL or the background brush
* Effect: 
*       Changes the text color if error is set
****************************************************************************/

HBRUSH CColoredEdit::CtlColor(CDC * pDC, UINT /*nCtlColor*/)
    {
     if(!error)
        return NULL;

     pDC->SetTextColor(RGB(255, 255, 0));
     return (HBRUSH)bk;
    }
