/*****************************************************************************
*           Change Log
*  Date     | Change
*-----------+-----------------------------------------------------------------
*  2-Dec-06 | Created change log
*  2-Dec-06 | IDC #001: Changed values to DWORD_PTR for Win64 compatibility
*****************************************************************************/
// IDCombo.h : header file
//
// Copyright  2005, Joseph M. Newcomer, All Rights Reserved
// You must record any changes you make to this source by putting // and your
// initials at the end of each line you change. You may not remove any lines
// from this source; instead, put // in front of them and your initials at the end.
// You may not charge any fee for the redistribution, nor incorporate this code in
// any commercial product. This is freeware, and must remain so.
//

/////////////////////////////////////////////////////////////////////////////
// CIDCombo window
#pragma once

typedef struct {
        UINT id;  // IDS_ for string, or 0 for end of table for AddStrings
        DWORD_PTR val; // value for itemdata                        // IDC #001
               } IDData;


class CIDCombo : public CComboBox
{
// Construction
public:
        CIDCombo();

// Attributes
public:

// Operations
public:
        int AddString(const IDData * data);
        int AddString(CString &s) { return CComboBox::AddString(s); }
        int AddString(LPCTSTR s)  { return CComboBox::AddString(s); }
        BOOL AddStrings(const IDData * data, DWORD_PTR def = 0);    // IDC #001
        int Select(DWORD_PTR itemval);                              // IDC #001
        DWORD_PTR GetCurItem();                                     // IDC #001

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIDCombo)
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CIDCombo();
        int maxlen;  // maximum number of items displayed
                     // 0 - no limit
                     // -1 - limit to screen height

        // Generated message map functions
protected:
        //{{AFX_MSG(CIDCombo)
        afx_msg void OnDropdown();
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
