// SHGetFolderPathExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "SHGetFolderPathExplorerDlg.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSHGetFolderPathExplorerDlg dialog



CSHGetFolderPathExplorerDlg::CSHGetFolderPathExplorerDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CSHGetFolderPathExplorerDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSHGetFolderPathExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_Control(pDX, IDC_CSIDL, c_CSIDLS);
DDX_Control(pDX, IDC_ENVIRONMENT, c_Environments);
DDX_Control(pDX, IDC_CODE, c_Code);
DDX_Control(pDX, IDC_CSIDL_FLAG_CREATE, c_CSIDL_FLAG_CREATE);
DDX_Control(pDX, IDC_PATH, c_Path);
DDX_Control(pDX, IDC_SHGFP_TYPE_CURRENT, c_SHGFP_TYPE_CURRENT);
DDX_Control(pDX, IDC_SHGFP_TYPE_DEFAULT, c_SHGFP_TYPE_DEFAULT);
DDX_Control(pDX, IDC_COPY, c_Copy);
DDX_Control(pDX, IDC_CREATE, c_Create);
}

BEGIN_MESSAGE_MAP(CSHGetFolderPathExplorerDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
    ON_WM_CLOSE()
    ON_CBN_SELCHANGE(IDC_CSIDL, OnCbnSelchangeCsidl)
    ON_WM_SIZE()
    ON_CBN_SELCHANGE(IDC_ENVIRONMENT, OnCbnSelchangeEnvironment)
    ON_BN_CLICKED(IDC_CSIDL_FLAG_CREATE, OnBnClickedCsidlFlagCreate)
    ON_BN_CLICKED(IDC_SHGFP_TYPE_CURRENT, OnBnClickedShgfpTypeCurrent)
    ON_BN_CLICKED(IDC_SHGFP_TYPE_DEFAULT, OnBnClickedShgfpTypeDefault)
    ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
    ON_BN_CLICKED(IDC_CREATE, OnBnClickedCreate)
END_MESSAGE_MAP()

const IDData CSIDLS[] = {
#define MAKE_CSIDL_ENTRY(x) {IDS_##x, x}
   MAKE_CSIDL_ENTRY(CSIDL_ADMINTOOLS),
   MAKE_CSIDL_ENTRY(CSIDL_COMMON_ADMINTOOLS),
   MAKE_CSIDL_ENTRY(CSIDL_APPDATA),
   MAKE_CSIDL_ENTRY(CSIDL_COMMON_APPDATA),
   MAKE_CSIDL_ENTRY(CSIDL_COMMON_DOCUMENTS),
   MAKE_CSIDL_ENTRY(CSIDL_COOKIES),
   MAKE_CSIDL_ENTRY(CSIDL_HISTORY),
   MAKE_CSIDL_ENTRY(CSIDL_INTERNET_CACHE),
   MAKE_CSIDL_ENTRY(CSIDL_LOCAL_APPDATA),
   MAKE_CSIDL_ENTRY(CSIDL_MYPICTURES),
   MAKE_CSIDL_ENTRY(CSIDL_PERSONAL),
   MAKE_CSIDL_ENTRY(CSIDL_PROGRAM_FILES),
   MAKE_CSIDL_ENTRY(CSIDL_PROGRAM_FILES_COMMON),
   MAKE_CSIDL_ENTRY(CSIDL_SYSTEM),
   MAKE_CSIDL_ENTRY(CSIDL_WINDOWS),
   {0, 0} // EOT
};

const IDData Environments[] = {
   { IDS_MFC,   IDS_MFC_TEMPLATE},
   { IDS_C,     IDS_C_TEMPLATE},
   { 0, 0} // EOT
};

// CSHGetFolderPathExplorerDlg message handlers

/****************************************************************************
*                  CSHGetFolderPathExplorerDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CSHGetFolderPathExplorerDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon

    c_Environments.AddStrings(Environments);
    c_Environments.Select(IDS_MFC_TEMPLATE);
    c_CSIDLS.AddStrings(CSIDLS);
    CheckRadioButton(IDC_SHGFP_TYPE_CURRENT, IDC_SHGFP_TYPE_DEFAULT, IDC_SHGFP_TYPE_CURRENT);
        
    CFont * font = c_Code.GetFont();
    ASSERT(font != NULL);
    LOGFONT lf;
    font->GetLogFont(&lf);
    StringCchCopy(lf.lfFaceName, sizeof(lf.lfFaceName)/sizeof(TCHAR), _T("Courier New"));
    fixed.CreateFontIndirect(&lf);
    c_Code.SetFont(&fixed);

    CBitmap bmp;
    bmp.LoadBitmap(IDB_COPY);
    c_Copy.SetBitmap(bmp);
    bmp.Detach();

    updateControls();
    
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSHGetFolderPathExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSHGetFolderPathExplorerDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSHGetFolderPathExplorerDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                    CSHGetFolderPathExplorerDlg::OnCancel
*                      CSHGetFolderPathExplorerDlg::OnOK
* Result: void
*       
* Effect: 
*       No effect whatsoever.  These prevent the app from being closed by
*       accidental use of <esc> or <enter>
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnCancel()
    {
    }

void CSHGetFolderPathExplorerDlg::OnOK()
    {
    }

/****************************************************************************
*                    CSHGetFolderPathExplorerDlg::OnClose
* Result: void
*       
* Effect: 
*       Forces the app to close
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*              CSHGetFolderPathExplorerDlg::OnCbnSelchangeCsidl
* Result: void
*       
* Effect: 
*       Forces a redraw, which will recognize the new CSIDL_ selection
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnCbnSelchangeCsidl()
    {
     Redraw(FALSE);
    }

/****************************************************************************
*                     CSHGetFolderPathExplorerDlg::OnSize
* Inputs:
*       UINT nType: Type of resize
*       int cx: new width
*       int cy: new height
* Result: void
*       
* Effect: 
*       Handles interior control resizing
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     if(c_Code.GetSafeHwnd() != NULL)
        { /* resize code display */
         CRect r;
         c_Code.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Code.SetWindowPos(NULL, 0, 0, cx, cy - r.top, SWP_NOMOVE | SWP_NOZORDER);
        } /* resize code display */

     if(c_Path.GetSafeHwnd() != NULL)
        { /* resize path */
         CRect r;
         c_Path.GetWindowRect(&r);
         ScreenToClient(&r);
         c_Path.SetWindowPos(NULL, 0, 0, cx - r.left, r.Height(), SWP_NOMOVE | SWP_NOZORDER);
        } /* resize path */
    }

/****************************************************************************
*           CSHGetFolderPathExplorerDlg::OnCbnSelchangeEnvironment
* Result: void
*       
* Effect: 
*       Forces a redraw, which will recognize the change from C to MFC or
*       whatever the current set of selections is
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnCbnSelchangeEnvironment()
    {
     Redraw(FALSE);
    }

/****************************************************************************
*                 CSHGetFolderPathExplorerDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CSHGetFolderPathExplorerDlg::updateControls()
    {
     CString s;
     c_Code.GetWindowText(s);
     s.Trim();
     c_Copy.EnableWindow(!s.IsEmpty());

     c_Create.EnableWindow(c_CSIDL_FLAG_CREATE.GetCheck() == BST_CHECKED);
     
    } // CSHGetFolderPathExplorerDlg::updateControls


/****************************************************************************
*                    CSHGetFolderPathExplorerDlg::GetPath
* Inputs:
*       int csidl: The csidl to use
*       DWORD flags: the flags to use
*       LPTSTR path: Path buffer, must be MAX_PATH characters
*       BOOL create: TRUE to honor creation flag, FALSE to ignore creation flag
* Result: HRESULT
*       The result of the SHGetFolderPath
* Effect: 
*       Looks up, or optionally creates, the folder path, and puts the path in
*       the c_Path window (or the error message if there was an error)
****************************************************************************/

HRESULT CSHGetFolderPathExplorerDlg::GetPath(int csidl, DWORD flags, LPTSTR path, BOOL create)
    {
     if(!create)
        csidl &= ~CSIDL_FLAG_CREATE;
     HRESULT result = ::SHGetFolderPath(NULL, (int)csidl, NULL, flags, path);

     if(SUCCEEDED(result))
        { /* succeeded */
         c_Path.SetWindowText(path);
         c_Path.SetErrorMode(FALSE);
        } /* succeeded */
     else
        { /* failed */
         CString err = ErrorString(result);
         c_Path.SetWindowText(err);
         c_Path.SetErrorMode(TRUE);
        } /* failed */
     return result;
    } // CSHGetFolderPathExplorerDlg::GetPath

/****************************************************************************
*                     CSHGetFolderPathExplorerDlg::Redraw
* Inputs:
*       BOOL WantCreate: TRUE to honor create flag, FALSE to ignore create flag
* Result: void
*       
* Effect: 
*       Redraws the contents of the edit control
****************************************************************************/

void CSHGetFolderPathExplorerDlg::Redraw(BOOL WantCreate)
    {
     if(c_Environments.GetCurSel() == CB_ERR)
        return;
     if(c_CSIDLS.GetCurSel() == CB_ERR)
        return;

     CString fmt;
     DWORD_PTR id = c_Environments.GetCurItem();
     fmt.LoadString((UINT)id);

     // %1: CSIDL name

     DWORD_PTR csidl;
     csidl = c_CSIDLS.GetCurItem();
     CString create;

     if(c_CSIDL_FLAG_CREATE.GetCheck() == BST_CHECKED)
        { /* create */
         csidl |= CSIDL_FLAG_CREATE;
         create = _T("CSIDL_FLAG_CREATE");
        } /* create */

     CString csidlname;
     c_CSIDLS.GetLBText(c_CSIDLS.GetCurSel(), csidlname);
     if(!create.IsEmpty())
        { /* add it */
         csidlname += _T(" | ");
         csidlname += create;
        } /* add it */

     TCHAR path[MAX_PATH];
     DWORD flags = 0;
     CString flagname;

     if(c_SHGFP_TYPE_CURRENT.GetCheck() == BST_CHECKED)
        { /* SHGFP_TYPE_CURRENT */
         flags = SHGFP_TYPE_CURRENT;
         flagname = _T("SHGFP_TYPE_CURRENT");
        } /* SHGFP_TYPE_CURRENT */
     else
     if(c_SHGFP_TYPE_DEFAULT.GetCheck() == BST_CHECKED)
        { /* SHGFP_TYPE_DEFAULT */
         flags = SHGFP_TYPE_DEFAULT;
         flagname = _T("SHGFP_TYPE_DEFAULT");
        } /* SHGFP_TYPE_DEFAULT */

     // %1 - CSIDL string
     // %2 - flags

     CString text;
     text.FormatMessage(fmt, csidlname, flagname);

     c_Code.SetWindowText(text);
     
     HRESULT result = GetPath((int)csidl, flags, path, WantCreate);

    } // CSHGetFolderPathExplorerDlg::Redraw
    

/****************************************************************************
*           CSHGetFolderPathExplorerDlg::OnBnClickedCsidlFlagCreate
* Result: void
*       
* Effect: 
*       Forces a redraw
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnBnClickedCsidlFlagCreate()
    {
     updateControls();
     Redraw(FALSE);
    }

/****************************************************************************
*          CSHGetFolderPathExplorerDlg::OnBnClickedShgptTypeCurrent
* Result: void
*       
* Effect: 
*       Redraws the controls based on the buttons
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnBnClickedShgfpTypeCurrent()
    {
     updateControls();
     Redraw(FALSE);
    }

/****************************************************************************
*          CSHGetFolderPathExplorerDlg::OnBnClickedShgfpTypeDefault
* Result: void
*       
* Effect: 
*       Changes the display based on the state of the buttons
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnBnClickedShgfpTypeDefault()
    {
     updateControls();
     Redraw(FALSE);
    }

/****************************************************************************
*                CSHGetFolderPathExplorerDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the text in the sample edit control to the clipboard
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnBnClickedCopy()
    {
     c_Code.SetRedraw(FALSE);
     int low;
     int high;
     c_Code.GetSel(low, high);
     c_Code.SetSel(0, -1);
     c_Code.SendMessage(WM_COPY);
     c_Code.SetSel(low, high);
     c_Code.SetRedraw(TRUE);
    }

/****************************************************************************
*               CSHGetFolderPathExplorerDlg::OnBnClickedCreate
* Result: void
*       
* Effect: 
*       Creates the folder
****************************************************************************/

void CSHGetFolderPathExplorerDlg::OnBnClickedCreate()
    {
     
    }
