// SHGetFolderPathExplorerDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "IDCombo.h"
#include "ColoredEdit.h"

// CSHGetFolderPathExplorerDlg dialog
class CSHGetFolderPathExplorerDlg : public CDialog
{
// Construction
public:
        CSHGetFolderPathExplorerDlg(CWnd* pParent = NULL);      // standard constructor

// Dialog Data
        enum { IDD = IDD_SHGETFOLDERPATHEXPLORER_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;

        // Generated message map functions
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        DECLARE_MESSAGE_MAP()
    virtual void OnCancel();
    virtual void OnOK();
protected:
    afx_msg void OnClose();
    afx_msg void OnCbnSelchangeCsidl();
    afx_msg void OnSize(UINT nType, int cx, int cy);
protected:  // control variables
    CIDCombo c_CSIDLS;
    CIDCombo c_Environments;
    CEdit c_Code;
    CButton c_CSIDL_FLAG_CREATE;
    CColoredEdit c_Path;
    CButton c_SHGFP_TYPE_CURRENT;
    CButton c_SHGFP_TYPE_DEFAULT;
    CButton c_Copy;
    CButton c_Create;
protected: // handlers
    afx_msg void OnCbnSelchangeEnvironment();
    afx_msg void OnBnClickedCsidlFlagCreate();
    afx_msg void OnBnClickedShgfpTypeCurrent();
    afx_msg void OnBnClickedShgfpTypeDefault();
    afx_msg void OnBnClickedCopy();
    afx_msg void OnBnClickedCreate();
protected: // methods
    void Redraw(BOOL WantCreate);
    void updateControls();
    HRESULT CSHGetFolderPathExplorerDlg::GetPath(int csidl, DWORD flags, LPTSTR path, BOOL create);
protected: // variables
    CFont fixed;
};
